zinc1IsReady = 0;
zinc2IsReady = 0;

/* the following three functions sets which type of interactive tools to use for scene */ 
function TransformTool()
{
	var zincPlugin = document.getElementById('zincplugin');
	zincPlugin.sceneViewer.setInteractiveToolByName('transform_tool');
	var scene2Plugin = document.getElementById('scene2');
	var sceneViewer2 = zincPlugin.getSceneViewerFromInteger(scene2Plugin.sceneViewerIntLow, scene2Plugin.sceneViewerIntHigh);
	sceneViewer2.setInteractiveToolByName('transform_tool');
}

function ElementTool()
{
	var zincPlugin = document.getElementById('zincplugin');
	zincPlugin.sceneViewer.setInteractiveToolByName('element_tool');
}

function NodeTool()
{
	var zincPlugin = document.getElementById('zincplugin');

	var heartRegion = zincPlugin.context.getDefaultRegion().findSubregionAtPath("heart");
	var graphicsModule = zincPlugin.context.getDefaultGraphicsModule();
	var heartRendition = graphicsModule.getRendition(heartRegion);
	heartRendition.executeCommand("node_point coordinate coordinates glyph sphere general size 0.5 centre 0,0,0 font default select_on material green selected_material default_selected");
	var scene2Plugin = document.getElementById('scene2');
	var sceneViewer2 = zincPlugin.getSceneViewerFromInteger(scene2Plugin.sceneViewerIntLow, scene2Plugin.sceneViewerIntHigh);
	sceneViewer2.setInteractiveToolByName('node_tool');
	var interactiveTool = sceneViewer2.getCurrentInteractiveTool();
	interactiveTool.executeCommand("group heart");
	interactiveTool.executeCommand("coordinate coordinates create define edit constrain_to_surfaces");
}

/* Function to set a create/get new group field and use it for selection*/
function Selection1()
{
	/* get an entry to zinc plugin */
	var zincPlugin = document.getElementById('zincplugin');
	/* get a graphics module from the plugin */
	var graphicsModule = zincPlugin.context.getDefaultGraphicsModule();
	/* get the root region */
	var rootRegion = zincPlugin.context.getDefaultRegion();
	/* get the subregion heart from root region */
	var heartRegion = rootRegion.findSubregionAtPath("heart");
	/* get the subregion coro0 from root region */
	var coroRegion = rootRegion.findSubregionAtPath("coro0");
	/* get the rendition for heart and coro0 region */
	var heartRendition = graphicsModule.getRendition(heartRegion);
	var coroRendition = graphicsModule.getRendition(coroRegion);
	/* get a field module from root region, field module is used to get and create
	new fields from each region */
	var fieldModule = rootRegion.getFieldModule();
	/* try to find a field from root region called Selection1 */
	var selectionField1 = fieldModule.findFieldByName("Selection1");
	if (!selectionField1)
	{
		/* create a group type field and set the name to Selection1*/
		selectionField1 = fieldModule.createGroup();
		selectionField1.setName("Selection1");
	}
	/* rendition from root region */
	var rootRendition = graphicsModule.getRendition(rootRegion);
	if (rootRendition && selectionField1)
	{
		/* ask roor and its childrens rendition to use the newly created selection
		field for its graphical selection */
		rootRendition.setSelectionGroup(selectionField1);
	}
	/*
	var rootSelection = rootRendition.getSelectionGroup();
	var heartSelection = heartRendition.getSelectionGroup();
	var coroSelection = coroRendition.getSelectionGroup();
	if (rootSelection)
		message = "rootRegion: " + rootSelection.getName() + "\n";
	if (heartSelection)
		message = message + heartRegion.getName() + ": " + heartSelection.getName() + "\n";
	if (coroSelection)
		message = message + coroRegion.getName() + ": " + coroSelection.getName();
	*/
	var message = 'Selection1';
}

/* Similar to the function Selection1 - create a new group field and use if for graphical selection*/
function Selection2()
{
	var zincPlugin = document.getElementById('zincplugin');
	var rootRegion = zincPlugin.context.getDefaultRegion();
	var fieldModule = rootRegion.getFieldModule();
	var selectionField2 = fieldModule.findFieldByName("Selection2");
	if (!selectionField2)
	{
		selectionField2 = fieldModule.createGroup();
		selectionField2.setName("Selection2");
	}
	var rootRendition = zincPlugin.context.getDefaultGraphicsModule().getRendition(rootRegion);
	if (rootRendition && selectionField2)
	{
		rootRendition.setSelectionGroup(selectionField2);
	}
	var message = 'selection2';
}

function removeMesh(meshName)
{
	var zincPlugin = document.getElementById('zincplugin');
	var heartRegion =  zincPlugin.context.getDefaultRegion().findSubregionAtPath("heart");
	var heartRendition = zincPlugin.context.getDefaultGraphicsModule().getRendition(heartRegion);
	var selection_group = heartRendition.getSelectionGroup();
	var masterMesh = heartRegion.getFieldModule().findMeshByName(meshName);
	if (selection_group && masterMesh)
	{
		var elementGroup = selection_group.getElementGroup(masterMesh);
		var mesh = elementGroup.getMesh();
		mesh.destroyAllElements();
	}
}

function RemoveSelectedLines()
{
	removeMesh("cmiss_mesh_1d");
}

function RemoveSelectedSurfaces()
{
	removeMesh("cmiss_mesh_2d");
}

/* Set the visibility of the heart region, this can be toggle on and off using the
	checkbox */
function ToggleHeartSurface(input)
{
	var command = "surfaces exterior face  xi3_0 texture_coordinates xi data coordinates spectrum heart_spectrum ";
	if (input.checked)
	{
		command = command + "visible";
	}
	else
	{
		command = command + "invisible";
	}
	var zincPlugin = document.getElementById('zincplugin');
	var HeartRegion = zincPlugin.context.getDefaultRegion().findSubregionAtPath("heart");
	if (HeartRegion)
	{
		var heartRendition = zincPlugin.context.getDefaultGraphicsModule().getRendition(HeartRegion);
		heartRendition.executeCommand(command);
	}
}

/* Set the visibility of the coronaries, this can be toggle on and off using the
	checkbox */
function ToggleCoronaries(input)
{
	var command = "cylinders radius general.1 material gold1 ";
	if (input.checked)
	{
		command = command + "visible";
	}
	else
	{
		command = command + "invisible";
	}
	var zincPlugin = document.getElementById('zincplugin');
	var Coro0Region = zincPlugin.context.getDefaultRegion().findSubregionAtPath("coro0");
	if (Coro0Region)
	{
		var rendition = zincPlugin.context.getDefaultGraphicsModule().getRendition(Coro0Region);
		rendition.executeCommand(command);
	}
}

function DisplayNodalCoordinates(input)
{
	var command = "node select_on material blue selected_material default_selected label nodeValue ";
	if (input.checked)
	{
		command = command + "visible";
	}
	else
	{
		command = command + "invisible";
	}
	var zincPlugin = document.getElementById('zincplugin');
	var HeartRegion = zincPlugin.context.getDefaultRegion().findSubregionAtPath("heart");
	if (HeartRegion)
	{
		var heartRendition = zincPlugin.context.getDefaultGraphicsModule().getRendition(HeartRegion);
		heartRendition.executeCommand(command);
	}
}


/* Use a wrapper to preserve the arguments until the callback is made */
function getDownloadsCoroReadyFunction(zincPluginIn, CoroNodesItemIn, CoroElementsItemIn)
{
	/* preserve the argumenst */
	var zincPlugin = zincPluginIn;
	var CoroNodesItem = CoroNodesItemIn;
	var CoroElementsItem = CoroElementsItemIn;
	/* the following block is called upon callback */
	return function()
	{
		/* get the rootRegion */
		var rootRegion = zincPlugin.context.getDefaultRegion();
		/* read the memoryblock into the region */
		var streamInformation = rootRegion.createStreamInformation();
		streamInformation.createResourceDownloadItem(CoroNodesItem);
		streamInformation.createResourceDownloadItem(CoroElementsItem);
		rootRegion.read(streamInformation);
		/* get the subregion which was read in */
		var coroRegion = rootRegion.findSubregionAtPath("coro0");

		if (coroRegion)
		{
			/* get the graphics module */ 
			var graphicsModule = zincPlugin.context.getDefaultGraphicsModule();
			/* get the rendition for region "coro0", rendition is an object that
			   contains different graphics for a region */
			var coroRendition = graphicsModule.getRendition(coroRegion);
			name = coroRegion.getName();
			/* create a new material */
			var gold_material = graphicsModule.createMaterial();
			/* set the name and properties for newly created material */ 
			gold_material.setName("gold1");
			var diffuseColour = [1.0,0.7,0];
			gold_material.setAttributeReal3(gold_material.ATTRIBUTE.DIFFUSE, diffuseColour);
			gold_material.setAttributeReal3(gold_material.ATTRIBUTE.AMBIENT, diffuseColour);
			gold_material.setAttributeReal3(gold_material.ATTRIBUTE.SPECULAR, [0.5,0.5,0.5]);
			gold_material.setAttributeReal(gold_material.ATTRIBUTE.SHININESS, 0.8);
			/* Rendition begin change to cache changes */
			coroRendition.beginChange();
			/* execute a command for a spccified rendition */
			coroRendition.executeCommand('general clear element_discretization 1 circle_discretization 6');
			coroRendition.executeCommand("cylinders radius general.1 material gold1");
			/* end cahcing changes and update the rendition */ 
			coroRendition.endChange();
			/* View everything in scene and set the antialias of the scene viewer to 4 */
			zincPlugin.sceneViewer.viewAll();
			zincPlugin.sceneViewer.antialiasMode=4;

		}
	}			
}

function sceneViewerSetNewScene(zincPlugin, sceneViewer, regionIn)
{
	var graphicsModule = zincPlugin.context.getDefaultGraphicsModule();
	var new_scene = graphicsModule.createScene();
	new_scene.setName("heart");
	new_scene.setRegion(zincPlugin.context.getDefaultRegion());
	/* there are two more filter options 
	createFilterGraphicName([graphic_name]); //filter graphic name
	
	If there are multiple scene filters, order of filters can affect the renditions
	*/ 
	var graphicFilterRegion = graphicsModule.createFilterRegion(regionIn);
	var graphicFilterVisibility= graphicsModule.createFilterVisibilityFlags(); //filter visibilityflag
	var graphicFilterOr = graphicsModule.createFilterOperatorAnd(); //Add a And filter, result will be determined by the collective filters in it
	graphicFilterOr.appendOperand(graphicFilterRegion);
	graphicFilterOr.appendOperand(graphicFilterVisibility);
	new_scene.setFilter(graphicFilterOr);
	sceneViewer.setScene(new_scene);
}

/* Use a wrapper to preserve the arguments until the callback is made,
	most of the function calls here are similar to the getDownloadsHeartReadyFunction*/
function getDownloadsHeartReadyFunction(zincPluginIn, HeartNodesItemIn, HeartElementsItemIn)
{
	var zincPlugin = zincPluginIn;
	var HeartNodesItem = HeartNodesItemIn;
	var HeartElementsItem = HeartElementsItemIn;

	return function()
	{
		var rootRegion = zincPlugin.context.getDefaultRegion();
		var streamInformation = rootRegion.createStreamInformation();
		streamInformation.createResourceDownloadItem(HeartNodesItem);
		streamInformation.createResourceDownloadItem(HeartElementsItem);
		rootRegion.read(streamInformation);
		var heartRegion = rootRegion.findSubregionAtPath("heart");
		if (heartRegion)
		{
			var graphicsModule = zincPlugin.context.getDefaultGraphicsModule();
			var heartRendition = graphicsModule.getRendition(heartRegion);
			var heart_material = graphicsModule.createMaterial();
			var fieldModule = heartRegion.getFieldModule();
			var coordinatesField = fieldModule.defineField("rc_coordinates", "coordinate_system rectangular_cartesian coordinate_transformation field coordinates");
			fieldModule.defineField("plane", "sum_components field rc_coordinates weights -1 1 1");
			var coordinatesField = fieldModule.findFieldByName("coordinates");
			var nodeValueField = fieldModule.createNodeValue(coordinatesField, 1, 1);
			nodeValueField.setName("nodeValue");
			nodeValueField.setAttributeInteger(nodeValueField.ATTRIBUTE.IS_MANAGED, 1);
			heart_material.setName("heart");
			heart_material.setAttributeReal3(heart_material.ATTRIBUTE.DIFFUSE, [1,0,0]);
			heart_material.setAttributeReal3(heart_material.ATTRIBUTE.AMBIENT, [0.3,0,0.3]);
			heart_material.setAttributeReal3(heart_material.ATTRIBUTE.SPECULAR, [0.5,0.5,0.5]);
			var greenMaterial = graphicsModule.createMaterial();
			greenMaterial.executeCommand("ambient 0 1 0 diffuse 0 1 0");
			greenMaterial.setName("green");
			var spectrum = graphicsModule.createSpectrum();
			spectrum.setName("heart_spectrum");
			spectrum.executeCommand("linear reverse range 0 1 extend_above extend_below rainbow colour_range 0 1 component 1");
			heartRendition.beginChange();
			heartRendition.executeCommand('general clear');
			heartRendition.executeCommand("surfaces exterior face  xi3_0 texture_coordinates xi data coordinates spectrum heart_spectrum");
			heartRendition.executeCommand("lines select_on material default selected_material default_selected");
			heartRendition.executeCommand("node select_on material blue selected_material default_selected label nodeValue");
			heartRendition.executeCommand("node glyph sphere size '2*2*2' select_on material blue selected_material default_selected");
			heartRendition.executeCommand("iso_surfaces iso_scalar plane iso_value 0 material silver");
			heartRendition.endChange();
			/* get graphic from a specified rendition at position 1 */
			var graphic = heartRendition.getFirstGraphic();
			if (graphic)
			{
				/* get a tessellation object currently used by grahic.
					An tessellation objects control the tessellation/discretization
					of a graphic */
				var tessellation = graphic.getTessellation();
				/* Set the properties for tessellation */
				var temp_array = new Array();
				temp_array[0] = 4;
				tessellation.setMinimumDivisions(temp_array);
				var temp_array2 = new Array();
				temp_array2[0] = 4;
				tessellation.setRefinementFactors(temp_array2);
			}
			var scene2Plugin = document.getElementById('scene2');
			var sceneViewer2 = zincPlugin.getSceneViewerFromInteger(scene2Plugin.sceneViewerIntLow, 
				scene2Plugin.sceneViewerIntHigh);
			sceneViewerSetNewScene(zincPlugin, sceneViewer2, heartRegion);
			sceneViewer2.viewAll();
			zincPlugin.sceneViewer.viewAll();
		}
	}			
}

function initialiseWhenReady()
{
	if (zinc1IsReady == 1 && zinc2IsReady == 1)
	{
		var scene2Plugin = document.getElementById('scene2');
		scene2Plugin.initialiseCmguiSharedInstance();
		/* an entry point to the zinc plugin */
		var zincPlugin = document.getElementById('zincplugin');
		ZN_OK = zincPlugin.OK;
		zincPlugin.context.getDefaultGraphicsModule().defineStandardMaterials();

		/* create another manager for reading in more files */
		var downloadManager2 = zincPlugin.createDownloadManager();
		var CoroNodesItem = downloadManager2.addURI("coro0.exnode");
		var CoroElementsItem = downloadManager2.addURI("coro0.exelem");
		downloadManager2.addCompletionCallback(
			getDownloadsCoroReadyFunction(zincPlugin, CoroNodesItem,CoroElementsItem));
						/* create a download manager for reading input files */
		var downloadManager = zincPlugin.createDownloadManager();
		/* add in URIs for downloadManager to read files from.
		 	In this case files from the local directories. Each item stores
		 	a block of memory for each file. */
		var HeartNodesItem = downloadManager.addURI("large_heart.exnode");
		var HeartElementsItem = downloadManager.addURI("large_heart.exelem");
		/* add in a completion callback function once the download manager has 
			 finish downloading and put the files into memory. In this case,
			 the function getDownloadsHeartReadyFunction will be called once
			 download is finished. */
		downloadManager.addCompletionCallback(
			getDownloadsHeartReadyFunction(zincPlugin, HeartNodesItem,HeartElementsItem));
	}
}


/* This function is called when the primary scene is constructed and read */
function zinc1ReadyFunction()
{
	zinc1IsReady = 1;
	initialiseWhenReady();
}

function zinc2ReadyFunction()
{
	zinc2IsReady = 1;
	initialiseWhenReady();
}
